Sentinel/Sentinel/Controllers/UploadsController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Logging;
using Sentinel.Models;
using Sentinel.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Sentinel.Controllers
{
    [Authorize(Roles = "User")]
    public class UploadsController : Controller
    {
        private readonly ILogger<UploadsController> _logger;
        private readonly SentinelContext _db;

        public UploadsController(ILogger<UploadsController> logger, SentinelContext db)
        {
            _logger = logger;
            _db = db;
        }

        public async Task<IActionResult> Index()
        {
            var vm = await _db.Sources.Select(s => new UploadSummaryViewModel(s)).ToListAsync();
            return View(vm);
        }

        public IActionResult Create()
        {
            var vm = new EditUploadViewModel();
            return View("CreateEdit", vm);
        }

        public async Task<IActionResult> Edit(int id)
        {
            var source = await _db.Sources.FindAsync(id);
            if (source == null) return BadRequest();

            var vm = new EditUploadViewModel(source);
            return View("CreateEdit", vm);
        }

        [HttpPost]
        [RequestSizeLimit(500_000)] // Limit file uploads to 500KB total
        public async Task<IActionResult> CreateEdit(EditUploadViewModel model)
        {
            try
            {
                if (model.SourceMap != null && model.SourceMap.ContentType != "text/plain")
                {
                    TempData["error"] = "Invalid content type for source map";
                    return RedirectToAction(nameof(Index));
                }
                else if (model.FullSource != null && model.FullSource.ContentType != "text/javascript")
                {
                    TempData["error"] = "Invalid content type for unminified source";
                    return RedirectToAction(nameof(Index));
                }
                if (model.Id == 0)
                {
                    // Create
                    if (model.SourceMap == null || model.FullSource == null)
                    {
                        TempData["error"] = "Source map and unminified source must be supplied!";
                        return RedirectToAction(nameof(Index));
                    }
                    Source s = new Source();
                    await model.UpdateSource(s);
                    _db.Sources.Add(s);
                    await _db.SaveChangesAsync();
                    TempData["message"] = "Upload created";
                }
                else
                {
                    // Edit
                    Source s = await _db.Sources.FindAsync(model.Id);
                    if (s == null)
                    {
                        TempData["error"] = "Can't find record to update";
                        return RedirectToAction(nameof(Index));
                    }
                    await model.UpdateSource(s);
                    await _db.SaveChangesAsync();
                    TempData["message"] = "Update successful";
                }
            }
            catch (Exception ex)
            {
                TempData["error"] = $"Error - {ex.Message}";
            }
            return RedirectToAction(nameof(Index));
        }

        public async Task<IActionResult> Delete(int id)
        {
            Source s = await _db.Sources.FindAsync(id);
            if (s == null)
            {
                return BadRequest();
            }
            _db.Sources.Remove(s);
            await _db.SaveChangesAsync();
            return RedirectToAction(nameof(Index));
        }
    }
}

Sentinel/Sentinel/Views/Shared/_Layout.cshtml
@using Microsoft.AspNetCore.Identity
@inject SignInManager<Authentication.Models.User> SignInManager

@{
    var isUser = (User.IsInRole("User"));
    var isAdmin = (User.IsInRole("Admin"));
    var applicationTitle = "Sentinel";
}

<!DOCTYPE html>
<html lang="en-gb">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="author" content="John Morgan, Solutions Development">
    @RenderSection("Metatags", false)
    <title>@ViewData["Title"] - @applicationTitle</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true"/>
    <link href="~/lib/toastr.js/toastr.min.css" rel="stylesheet" />
    <link href="~/lib/font-awesome/css/all.min.css" rel="stylesheet" />
    <link rel="icon" href="@Url.Content("~/favicon.ico")" />
    @RenderSection("ExtraCss", required: false)
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-dark bg-ydh-purple shadow-sm mb-2">
            <div class="container-fluid">
                <div class="navbar-brand">
                    <img src="~/images/YDH-circle-white-150.png" height="40" width="40" alt="YDH" />
                    <span>@applicationTitle</span>
                </div>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse" id="navbarSupportedContent">
                    <partial name="_LoginPartial" />
                    <ul class="navbar-nav flex-grow-1">
                        @if (isUser)
                        {
                            <li class="nav-item">
                                <a class="nav-link text-white" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link text-white" asp-area="" asp-controller="Uploads" asp-action="Index">Uploads</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link text-white" asp-area="" asp-controller="User" asp-action="Index">User admin</a>
                            </li>
                        }
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container-fluid">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2020 - YDH
        </div>
    </footer>
    <script src="~/lib/jquery/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/lib/font-awesome/js/all.min.js"></script>
    <script src="~/lib/toastr.js/toastr.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>